function init(){

	if(tinyMCE.getWindowArg('serverIp')==""||tinyMCE.getWindowArg('basePath')==""){
		alert("Some window parameters don't initialised!");
		return;
	}

	var inst = tinyMCE.getInstanceById(tinyMCE.getWindowArg('editor_id'));
	var elm = inst.selection.getFocusElement(inst);
	elm = tinyMCE.getParentElement(elm, "a");

	//   ,       href-     
	if(elm!=null){
		document.getElementById("link-textarea").value = elm.getAttribute("href");
		document.getElementById("insert-button").innerHTML = "Update";
	}
}


function InsertLink(){
	var inst = tinyMCE.getInstanceById(tinyMCE.getWindowArg('editor_id'));
	var elm = inst.selection.getFocusElement(inst);
	elm = tinyMCE.getParentElement(elm, "a");

	//   ,    ,     
	if(elm!=null){
		var wndType = document.getElementById("target-window").options[document.getElementById("target-window").options.selectedIndex].value;
		elm.href = document.getElementById("link-textarea").value;
		elm.setAttribute("mce_href", document.getElementById("link-textarea").value);
		if(wndType=="new")
		elm.setAttribute("target","_blank");
		else
		elm.setAttribute("target","_self");
	}
	else{
		var insertStr = "<a href='"+document.getElementById("link-textarea").value+"'>"+inst.selection.getSelectedHTML()+"</a>"
		inst.execCommand("mceInsertContent", false, insertStr);
	}

}


/**
*	       
*/
function OnSelectNode(evt){
	if(!document.getElementById("link-to-node").checked)
	return
	
	var element;
	if(window.event){
		element = window.event.srcElement;
		//  IE   - OPTION   ,  
		//  element  
		element = element.options[element.selectedIndex];
	}
	else{
		element = evt.target;
	}
	
	if(element.nodeName!="OPTION")
		return;	
	
	var nodeId = element.value;

	var path = "";
	if(!document.getElementById("relative-link").checked){
		path += "http://";
		path += tinyMCE.getWindowArg('serverIp');
		path += tinyMCE.getWindowArg('basePath');
	}
	path += "index.php?q=node/"+nodeId;
	document.getElementById("link-textarea").value = path;
}

/**
*	       
*/
function OnSelectTerm(evt){
	var element;
	if(window.event){
		element = window.event.srcElement;
		//  IE   - OPTION   ,  
		//  element  
		element = element.options[element.selectedIndex];
	}
	else{
		element = evt.target;
	}

	if(element.nodeName!="OPTION")
		return;	
	
	//   -  ,         
	//   -  ,       ,    
	if(document.getElementById("link-to-node").checked){

		if(!document.getElementById("select-by-vocabulary").checked)
		return;
		var termId = element.value;

		var strRequest = tinyMCE.getWindowArg('basePath') + "?q=tinymce_drupal_link/get_node_list/"+termId;
		if(document.getElementById("do-not-show").checked)
			strRequest +="/1";

		var req = CreateAjax();
		req.open("GET", strRequest, false);
		req.send(null);
		if(req.status==200){
			if(req.responseText!="error"){
				document.getElementById("tinymce-drupal-link-node-list").parentNode.innerHTML = req.responseText;
			}
			else{
				alert("Server error");
				return;
			}
		}
	}
	else{
		var termId = element.value;
		var path = "";
		if(!document.getElementById("relative-link").checked){
			path += "http://"
			path += tinyMCE.getWindowArg('serverIp');
			path += tinyMCE.getWindowArg('basePath')
		}
		 path += "index.php?q=taxonomy/term/"+termId;
		document.getElementById("link-textarea").value = path;
	}
}

/**
*     "Select by vocabulary"
*     ( ) -    
*     -   ,   -     
*/
function SelectByVocabulary(evt){
	var element;
	if(window.event)
	element = window.event.srcElement;
	else
	element = evt.target;

	if(!element.checked){
		var strRequest = tinyMCE.getWindowArg('basePath') + "?q=tinymce_drupal_link/get_node_list/full";
		if(document.getElementById("do-not-show").checked)
			strRequest +="/1";

		var req = CreateAjax();
		req.open("GET", strRequest, false);
		req.send(null);
		if(req.status==200){
			if(req.responseText!="error"){
				document.getElementById("tinymce-drupal-link-node-list").parentNode.innerHTML = req.responseText;
			}
			else{
				alert("Server error");
				return;
			}
		}
	}
}

/**
*    "  "
*       
*  ,      ,     
*       OnSelectTerm,       SelectByVocabulary
*         .
*/
function HideNotPublished(evt){
	if(document.getElementById("link-to-category").checked)
		return;
		
	var element;
	if(window.event)
	element = window.event.srcElement;
	else
	element = evt.target;
	
	if(element.checked){
		if(document.getElementById("select-by-vocabulary").checked){
			var select = document.getElementById("tinymce-drupal-link-term-list");
			var termId
			//       -     ,
			//  ,     
			if(select.selectedIndex==(-1))
				termId = "full";
			else
				termId= select.options[select.selectedIndex].value;
			var strRequest = tinyMCE.getWindowArg('basePath') + "?q=tinymce_drupal_link/get_node_list/"+termId+"/1";
		}
		else{
			var strRequest = tinyMCE.getWindowArg('basePath') + "?q=tinymce_drupal_link/get_node_list/full/1";
		}
	}
	else{
		if(document.getElementById("select-by-vocabulary").checked){
			var select = document.getElementById("tinymce-drupal-link-term-list");
			var termId;
			//       -     ,
			//  ,     
			if(select.selectedIndex==(-1))
				termId = "full";
			else
				termId= select.options[select.selectedIndex].value;
			var strRequest = tinyMCE.getWindowArg('basePath') + "?q=tinymce_drupal_link/get_node_list/"+termId;
		}
		else{
			var strRequest = tinyMCE.getWindowArg('basePath') + "?q=tinymce_drupal_link/get_node_list/full";
		}
	}
	var req = CreateAjax();
	req.open("GET", strRequest, false);
	req.send(null);
	if(req.status==200){
		if(req.responseText!="error"){
			document.getElementById("tinymce-drupal-link-node-list").parentNode.innerHTML = req.responseText;
		}
		else{
			alert("Server error");
			return;
		}
	}
}

/**
*     (    )
*      
*/
function LinkType(evt){
	var element;
	if(window.event)
	element = window.event.srcElement;
	else
	element = evt.target;

	if(element.id=="link-to-category"){
		document.getElementById("tinymce-drupal-link-node-list").disabled = true;
	}
	else{
		document.getElementById("tinymce-drupal-link-node-list").disabled = false;
	}
}

function CreateAjax(){
	if (window.ActiveXObject) {
		return new ActiveXObject("Microsoft.XMLHTTP");
	}
	else if (window.XMLHttpRequest) {
		return new XMLHttpRequest();
	}
}